/*
	$Id: inputsource_provider_file.h,v 1.6 2001/09/22 15:52:10 plasmoid Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanCore="I/O Data"
//! header=core.h

#ifndef header_inputsource_provider_file
#define header_inputsource_provider_file

class CL_InputSource;
#include "inputsource_provider.h"

//: The Input Source Provider File Class
class CL_InputSourceProvider_File : public CL_InputSourceProvider
{
//! Construction:
public:
	//: The Input Source Provider File Constructor
	CL_InputSourceProvider_File(const char *path);

	//: Open Source
	virtual CL_InputSource *open_source(const char *filename);

	//: Clone
	virtual CL_InputSourceProvider *clone();

//! Implementation:
private:
	std::string provider_path;
};

#endif
