/*
	$Id: component_manager.h,v 1.17 2001/09/22 15:52:15 plasmoid Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanGUI="Framework"
//! header=gui.h

#ifndef header_component_manager
#define header_component_manager

#include "component.h"
#include "component_type.h"

#include <string>
#include <map>

class CL_StyleManager;
class CL_ResourceManager;
class CL_ComponentType;

//: Manages the components
class CL_ComponentManager
{
public:
//! Construction:
	//: Create
	static CL_ComponentManager *create(
		const char *resource_id,
		CL_ResourceManager *res_manager,
		CL_StyleManager *style, 
		CL_Component *parent);

	//: Create
	static CL_ComponentManager *create(
		const char *filename,
		bool is_datafile,
		CL_StyleManager *style, 
		CL_Component *parent);
		
	//: Component Manager Destructor
	virtual ~CL_ComponentManager() { return; }

//! Attributes:
	//: Get Component
	virtual CL_Component *get_component(const char *component_id) = 0;

	//: Component types
	static std::map<std::string, CL_ComponentType *> component_types;
};

#endif
