/*
	$Id: stylemanager.h,v 1.27 2001/09/22 15:52:16 plasmoid Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanGUI="Framework"
//! header=gui.h

#ifndef header_stylemanager
#define header_stylemanager

#include <string>

class CL_ComponentOptions;
class CL_Component;
class CL_ResourceManager;
class CL_StyleManager_Generic;

//! Manages the overall style of the system
class CL_StyleManager
{
//! Construction:
public:
	//: Style Manager Constructor
	CL_StyleManager(CL_ResourceManager *resources);

	//: Style Manager Destructor
	virtual ~CL_StyleManager();

//! Attributes:
public:
	//: Get Resources
	CL_ResourceManager *get_resources();

//! Overrideables:
public:
	//: Create Component
	virtual CL_Component *create_component(
		const std::string &type,
		const CL_ComponentOptions &options,
		CL_Component *parent)=0;

	//: Connect Styles
	virtual void connect_styles(
		const std::string &type,
		const CL_ComponentOptions &options,
		CL_Component *owner)=0;

//! Implementation:
private:
	CL_StyleManager(const CL_StyleManager &copy) { return; } // disallow copy contruction
	CL_StyleManager_Generic *impl;
};

#endif
