/*
	$Id: vorbis_soundprovider.h,v 1.12 2001/10/10 11:50:28 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//! clanVorbis="Sound Providers"
//! header=vorbis.h

#ifndef header_vorbis_soundprovider
#define header_vorbis_soundprovider

#include "../core.h"
#include "../Sound/stream_soundprovider.h"
#include "../Sound/soundbuffer.h"

class CL_VorbisSoundProvider_Generic;

//: Vorbis Sound Provider Class
class CL_VorbisSoundProvider : public CL_StreamSoundProvider
{
public:
//! Construction:
	//: Vorbis Sound Provider Constructor
	CL_VorbisSoundProvider(
		const std::string &name,
		CL_InputSourceProvider *provider = NULL,
		bool delete_provider = false);

	//: Vorbis Sound Provider Constructor
	CL_VorbisSoundProvider(
		const std::string &name,
		CL_ResourceManager *resources);

	//: Vorbis Sound Provider Destructor
	virtual ~CL_VorbisSoundProvider();

//! Operations:
	//: Begin Session
	virtual CL_StreamSoundProvider_Session *begin_session();

	//: End Session
	virtual void end_session(CL_StreamSoundProvider_Session *session);

//! Implementation:
private:
	CL_VorbisSoundProvider(const CL_VorbisSoundProvider &copy) { return; } // disallow copy construction.
	CL_VorbisSoundProvider_Generic *impl;
};

#endif
