/*
	$Id: gui.h,v 1.29 2001/09/16 15:06:38 japj Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	See http://www.clanlib.org
	------------------------------------------------------------------------
*/

//: <p>Graphical User Interface API. Provides a themeable and very flexible GUI
//: framework.</p>
//! Global=GUI

#ifndef header_gui
#define header_gui

#ifdef WIN32
#pragma warning( disable : 4786)
#endif

// Framework
#include "GUI/setupgui.h"
#include "GUI/component.h"
#include "GUI/component_manager.h"
#include "GUI/component_type.h"
#include "GUI/component_move_handler.h"
#include "GUI/component_resize_handler.h"
#include "GUI/component_style.h"
#include "GUI/stylemanager.h"
#include "GUI/stylemanager_default.h"
#include "GUI/gui_manager.h"
#include "GUI/layout_manager.h"

// Components
#include "GUI/label.h"
#include "GUI/frame.h"
#include "GUI/button.h"
#include "GUI/combobox.h"
#include "GUI/image.h"
#include "GUI/inputbox.h"
#include "GUI/scrollbar.h"
#include "GUI/progressbar.h"
#include "GUI/menubar.h"
#include "GUI/menuitem.h"
#include "GUI/popupmenu.h"
#include "GUI/checkbox.h"
#include "GUI/listbox.h"
#include "GUI/treeview.h"
#include "GUI/window.h"

// Dialogs
#include "GUI/messagebox.h"
#include "GUI/filedialog.h"

#endif
